;; reverse transformation 

;; 12 (reverse) 
(haskell-refac-moveDefBetweenModules "allwords" "LineStorage" "Shifter" )
(haskell-refac-demoteTopLevel "allwords" "Shifter")
(haskell-refac-demoteIn "allwords" "cssetup" "Shifter")

;; 11 (reverse)
(haskell-refac-moveDefBetweenModules "line" "LineStorage" "Shifter")
(haskell-refac-unfoldIn "line" "printable_csline" "Shifter") 
(haskell-refac-unfoldIn "line" "printable_csline" "Shifter")
(haskell-refac-unfoldIn "line" "cswords" "Shifter")
(haskell-refac-unfoldIn "line" "csword" "Shifter")
(haskell-refac-unfoldIn "line" "csword" "Shifter")
(haskell-refac-removeTopLevelDef "line" "Shifter")

; remark : compared to the original program, a linebreak \n is added at this point.

;; 10 (reverse)
(haskell-refac-unfoldIn "alphcslines" "allalphcslines" "Output")
(haskell-refac-removeTopLevelDef "alphcslines" "Alphabet")

;; 9 (reverse)
(haskell-refac-unfoldIn "alphcsline" "allalphcslines" "Output")
(haskell-refac-removeTopLevelDef "alphcsline" "Alphabet" )

;; 8 (reverse)
(haskell-refac-moveDefBetweenModules "printable_csline"  "Shifter" "Output" )
(haskell-refac-demoteTopLevel "printable_csline" "Output") 
(haskell-refac-renameLocalIdentIn "printable_csline" "Output" "csline" )

;; 7 (reverse) 
(haskell-refac-moveDefBetweenModules "csline"  "Shifter" "Alphabet" ) 
(haskell-refac-demoteTopLevel "csline" "Alphabet") 
(haskell-refac-unfoldIn "csline" "alph" "Alphabet")
(haskell-refac-removeLocalDefIn "csline" "alph" "Alphabet" ) 

;; 6 (reverse) 
(haskell-refac-moveDefBetweenModules "cslines" "Shifter" "Alphabet"  )
(haskell-refac-unfoldIn "cslines" "alph" "Alphabet")
(haskell-refac-removeTopLevelDef "cslines" "Alphabet" )
;; there is a difference in the layout in Shifter

;; 5 (reverse)
(haskell-refac-demoteTopLevel "cswords" "Shifter")
(haskell-refac-demoteTopLevel "csword" "Shifter")
(haskell-refac-moveDefBetweenModules "csline_inf" "Shifter" "Alphabet" ) 
(haskell-refac-demoteTopLevel "csline_inf" "Alphabet")
;;csline_inf is not at the same place in the local declarations of Alphabet.alph, but the semantics is the same.


;; 4 (reverse)
(haskell-refac-moveDefBetweenModules "emptyStorage"  "LineStorage" "Input")
(haskell-refac-unfoldIn "emptyStorage" "putfile" "Input")
(haskell-refac-removeTopLevelDef "emptyStorage" "Input" )

;; 3 (reverse)
(haskell-refac-moveDefBetweenModules "ls_words" "LineStorage" "Shifter"  )
(haskell-refac-unfoldIn "ls_words" "cssetup" "Shifter")
(haskell-refac-removeTopLevelDef "ls_words" "Shifter" )

;; 2 (reverse)
(haskell-refac-moveDefBetweenModules "ls_lines" "LineStorage" "Shifter" )
(haskell-refac-unfoldIn "ls_lines" "cssetup" "Shifter")
(haskell-refac-removeTopLevelDef "ls_lines" "Shifter" )

;; 1 (reverse)
(haskell-refac-moveDefBetweenModules "insline" "LineStorage" "Input" )
(haskell-refac-demoteTopLevel "insline" "Input")
(haskell-refac-cleanImportsMod "Input")
(haskell-refac-cleanImportsMod "Shifter"); makes import Input disappear :-(
;; again, there is a switch in the order of two functions that is semantically correct.
